#!hs2
#!load hamster.hsm

#####################################################################
# Skrypt    : Kill_From_All.hsc
# Autor     : Nuta <nuta@konto.pl>
# Strona WWW: http://hamster.thebat.pl
# Wersja    : 2001-05-23
# Poprawki  : 2002-05-13
# ===================================================================
# Opis    : Skrypt usuwajcy wszystkie artykuy ze wszystkich grup
#         : news Twojego Hamstera pochodzce z podanego adresu
#         : nadawcy. Peen opis dziaania i instalacji skryptu
#         : zawarty zosta w doczanym pliku Kill_From_All.txt.
#####################################################################

HamRequireVersion("1.3.22.1", True)

Var($Nadawca, $ListaGrup, $LiczAll, $i, $Ok)

repeat

  $Nadawca = ""
  repeat
    repeat
      $Nadawca = InputBox("Wpisz adres kasowanego nadawcy (np. login@domena.pl):", "Kill_From_All - kasowanie artykuw wybranego nadawcy", $Nadawca, $Ok)
      if ($Ok=0)
        quit
      endif
    until ($Nadawca <> "")

    if ((pos("@", $Nadawca) = 0) || (pos(".", $Nadawca) = 0))
      MsgBox("Adres: "+$Nadawca+" jest nieprawidowy!"+chr(10)+"Wpisz poprawny adres e-mail nadawcy.", "Kill_From_All - kasowanie artykuw wybranego nadawcy", 0x10|0x0)
    endif
  until ((pos("@", $Nadawca) > 0) && (pos(".", $Nadawca) > 0) && ($Ok <> 0))

  $ListaGrup = ListAlloc
  if (ListLoad($ListaGrup, HamPath + "Groups.hst") = -1)
    ListFree($ListaGrup)
    print("Plik z list grup: " +HamPath+ "Groups.hst nie istnieje!")
    quit
  endif

  $LiczAll = 0

  for ($i, 0, ListCount($ListaGrup)-1)
    Del_From(ListGet($ListaGrup,$i))
  endfor

  ListFree($ListaGrup)
  print
  if ($LiczAll > 0)
    print("cznie skasowano ",$LiczAll," artykuw pochodzcych od nadawcy: ",$Nadawca)
  else
    print("adna grupa nie zawieraa artykuu wysanego z adresu: ",$Nadawca)
  endif

until (Msgbox("Czy ponawiasz prb dla innego zestawu danych?", "Kill_From_All - kasowanie artykuw wybranego nadawcy",0x20|0x4) = 7)

quit


sub Del_From($Grupa)

  Var($Uchwyt, $MaxArt, $NrArt, $TextArt)
  Var($Mid, $From, $Licz, $AllArt, $MaxAllArt) 
  Var($Start1, $Stop1, $LiczArt)

  $Uchwyt = HamGroupOpen($Grupa)

  $NrArt = HamArtNoMin($Uchwyt)
  $MaxArt = HamArtNoMax($Uchwyt)
  $AllArt = HamArtCount($Uchwyt)
  $MaxAllArt = $MaxArt-$NrArt
  $LiczArt = 0
  $Licz = 0
  $Start1 = ticks

  print
  if ($AllArt > 0)
    print("Grupa: ",$Grupa," zawiera ",$MaxAllArt+1," artykuw z czego ",$AllArt," niepustych. Prosz czeka...")
  else
    HamGroupClose($Uchwyt)
    print("Grupa: ",$Grupa," nie zawiera niepustych artykuw do analizy!")
    endsub
  endif

  while ($NrArt <= $MaxArt)
    $TextArt = HamArtText($Uchwyt, $NrArt)
    if ($TextArt <> "")      
      if (pos($Nadawca, $TextArt) > 0)
        RE_Parse($TextArt, "\nFrom:\s+(.+@.+)\r", $From)
        if (pos($Nadawca, $From) > 0)
          RE_Parse($TextArt, "\nMessage-ID:\s+(<.+@.+>)\r", $Mid)
          HamArtDeleteMid($Mid)
          print("Skasowano artyku nr: ",$NrArt,"  M-ID: ",$Mid)
          inc($Licz)
        endif
      endif
      inc($LiczArt)
    endif  
    inc($NrArt)

    $Stop1 = ticks
    if (($Stop1-$Start1) > 30000)
      print("Wykonano ",100-Int(($AllArt-$LiczArt)/($AllArt/100)),"% zadania. Pozostao jeszcze ",$AllArt-$LiczArt," artykuw do analizy. Czekaj...")
      $Start1 = ticks
    endif
  endwhile

  HamGroupClose($Uchwyt)

  print("W grupie: ",$Grupa," znajdowao si ",$AllArt," niepustych artykuw, z ktrych")
  if ($Licz > 0)
    print($Licz," pochodzcych od nadawcy: ",$Nadawca," skasowano.")
    $LiczAll = $LiczAll + $Licz
  else
    print("aden nie zosta wysany z adresu: ",$Nadawca)
  endif

endsub
